<template>
    <div class="vertical-valve">
        <slot></slot>
        <div :style="{ width: width, height: calculatedHeight }" class="position-relative font-weight-normal">
            <div v-if="labelTop"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-x"
                 style="top: -30%">
                {{ labelTop }}
            </div>

            <div v-if="labelBottom"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-x"
                 style="bottom: -50%;">
                {{ labelBottom }}
            </div>

            <div v-if="labelRight"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="left:110%">
                {{ labelRight }}
            </div>

            <div v-if="labelLeft"
                 :style="{ 'font-size': fontSize }"
                 class="position-absolute center-y"
                 style="right: 130%">
                {{ labelLeft }}
            </div>

            <svg height="100%" viewBox="0 0 45 80" width="100%" xmlns="http://www.w3.org/2000/svg">
                <line :class="{'line-default' : !lineColor}" :stroke="lineColor ? lineColor : null"
                      stroke-width="4" x1="45%"
                      x2="45%"
                      y1="0"
                      y2="90">
                </line>
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="18,40 0,27, 0,53"
                         stroke-width="1"
                />
                <polygon :class="fillClass + (!strokeColor ? ' stroke-default': null)"
                         :stroke="strokeColor ? strokeColor : null"
                         class="triangle"
                         points="22,40 40,27, 40,53"
                         stroke-width="1"
                />
            </svg>
        </div>
    </div>
</template>

<script>
export default {
    name: 'vertical-valve-component',
    props: {
        labelTop: {
            type: String,
        },
        labelBottom: {
            type: String,
        },
        labelRight: {
            type: String,
        },
        labelLeft: {
            type: String,
        },
        width: {
            type: [Number, String],
            default: '3rem'
        },
        height: {
            type: [Number, String],
        },
        status: {
            type: String,
            default: 'on'
        },
        fontSize: {
            type: String,
            default: '1.2rem'
        },
        lineColor: {
            type: String,
        },
        strokeColor: {
            type: String
        }
    },
    data: () => {
        return {}
    },
    computed: {
        fillClass: function () {
            if (this.status === 'on') {
                return 'fill-on'
            }

            if (this.status === 'trip') {
                return 'fill-trip'
            }

            return 'fill-off'
        },
        calculatedHeight: function () {
            if (this.height) {
                return this.height;
            }

            return ((parseFloat(this.width).toFixed(2) / 45) * 80) + 'rem'
        }
    }
}
</script>
